{{- if .Values.ingress.enabled }}
{{- range $secret := .Values.basicAuth }}
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: {{ printf "%s-%s"  (include "webserver.fullname" $) $secret.name }}
  namespace: {{ $.Release.Namespace }}
  labels:
    app.kubernetes.io/name: {{ printf "%s-%s"  (include "webserver.fullname" $) $secret.name }}
    app.kubernetes.io/component: ingress
    {{- include "webserver.labels" $ | nindent 4 }}
spec:
  basicAuth:
    secret: {{ $secret.name }}
---
{{- end }}
apiVersion: traefik.containo.us/v1alpha1
kind: IngressRoute
metadata:
  name: {{ include "webserver.fullname" . }}
  namespace: {{ .Release.Namespace }}
  labels:
    app.kubernetes.io/name: {{ include "webserver.fullname" . }}
    app.kubernetes.io/component: ingress
    {{- include "webserver.labels" . | nindent 4 }}
spec:
  entryPoints:
    - websecure
  routes:
    - kind: Rule
      match: {{ printf "Host(`%s`)" .Values.ingress.hosts.host }}
      {{- with $.Values.ingress.additionalMiddlewares }}
      middlewares:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      services:
        - name: {{ printf "%s-nginx" (include "webserver.fullname" $) }}
          port: {{ $.Values.nginx.service.port }}
    {{- range $secret := $.Values.basicAuth }}
    {{- range $path := $secret.paths }}
    - kind: Rule
      match: {{ printf "Host(`%s`) && PathPrefix(`%s`)" $.Values.ingress.hosts.host $path}}
      middlewares:
        {{- with $.Values.ingress.additionalMiddlewares }}
        {{- toYaml . | nindent 8 }}
        {{- end }}
        - name: {{ printf "%s-%s"  (include "webserver.fullname" $) $secret.name }}
          namespace: {{ $.Release.Namespace }}
      services:
        - name: {{ printf "%s-nginx" (include "webserver.fullname" $) }}
          port: {{ $.Values.nginx.service.port }}
    {{- end }}
    {{- end }}
  tls:
    certResolver: {{ .Values.ingress.tls.certResolver }}
---
{{- range $alias := .Values.ingress.hosts.aliases }}
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: {{ printf "%s-redirect-%s" (include "webserver.fullname" $) $alias }}
  namespace: {{ $.Release.Namespace }}
  labels:
    app.kubernetes.io/name: {{ printf "%s-redirect-%s" (include "webserver.fullname" $) $alias }}
    app.kubernetes.io/component: ingress
    {{- include "webserver.labels" $ | nindent 4 }}
spec:
  redirectRegex:
    regex: ^https?://{{ $alias | replace "." "\\." }}(.*)
    replacement: https://{{ $.Values.ingress.hosts.host }}${1}
    permanent: true
---
{{- end }}
{{- range $alias := .Values.ingress.hosts.aliases }}
apiVersion: traefik.containo.us/v1alpha1
kind: IngressRoute
metadata:
  name: {{ printf "%s-redirect-%s" (include "webserver.fullname" $) $alias }}
  namespace: {{ $.Release.Namespace }}
  labels:
    app.kubernetes.io/name: {{ printf "%s-redirect-%s" (include "webserver.fullname" $) $alias }}
    app.kubernetes.io/component: ingress
    {{- include "webserver.labels" $ | nindent 4 }}
spec:
  entryPoints:
    - websecure
  routes:
    - kind: Rule
      match: {{ printf "Host(`%s`)" $alias }}
      middlewares:
        {{- with $.Values.ingress.additionalMiddlewares }}
        {{- toYaml . | nindent 8 }}
        {{- end }}
        - name: {{ printf "%s-redirect-%s" (include "webserver.fullname" $) $alias }}
          namespace: {{ $.Release.Namespace }}
      services:
        - kind: TraefikService
          name: noop@internal
  tls:
    certResolver: {{ $.Values.ingress.tls.certResolver }}
---
{{- end }}
{{- end }}
